/* ------------------------------------------------------------
name: "FaustClarinet"
Code generated with Faust 2.15.8 (https://faust.grame.fr)
Compilation options: cpp, -scal -ftz 0
------------------------------------------------------------ */

#ifndef  __mydsp_H__
#define  __mydsp_H__

#include "FaustClarinet.h"
// IMPORTANT: in order for MapUI to work, the teensy linker must be g++
/************************************************************************
 FAUST Architecture File
 Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
 ---------------------------------------------------------------------
 This Architecture section is free software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 3 of
 the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; If not, see <http://www.gnu.org/licenses/>.
 
 EXCEPTION : As a special exception, you may create a larger work
 that contains this FAUST architecture section and distribute
 that work under terms of your choice, so long as this FAUST
 architecture section is not modified.
 ************************************************************************/

#ifndef FAUST_MAPUI_H
#define FAUST_MAPUI_H

#include <vector>
#include <map>
#include <string>

/************************************************************************
 FAUST Architecture File
 Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
 ---------------------------------------------------------------------
 This Architecture section is free software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 3 of
 the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; If not, see <http://www.gnu.org/licenses/>.
 
 EXCEPTION : As a special exception, you may create a larger work
 that contains this FAUST architecture section and distribute
 that work under terms of your choice, so long as this FAUST
 architecture section is not modified.
 ************************************************************************/

#ifndef __UI_H__
#define __UI_H__

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

/*******************************************************************************
 * UI : Faust DSP User Interface
 * User Interface as expected by the buildUserInterface() method of a DSP.
 * This abstract class contains only the method that the Faust compiler can
 * generate to describe a DSP user interface.
 ******************************************************************************/

struct Soundfile;

class UI
{

    public:

        UI() {}

        virtual ~UI() {}

        // -- widget's layouts

        virtual void openTabBox(const char* label) = 0;
        virtual void openHorizontalBox(const char* label) = 0;
        virtual void openVerticalBox(const char* label) = 0;
        virtual void closeBox() = 0;

        // -- active widgets

        virtual void addButton(const char* label, FAUSTFLOAT* zone) = 0;
        virtual void addCheckButton(const char* label, FAUSTFLOAT* zone) = 0;
        virtual void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) = 0;
        virtual void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) = 0;
        virtual void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) = 0;

        // -- passive widgets

        virtual void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) = 0;
        virtual void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) = 0;
    
        // -- soundfiles
    
        virtual void addSoundfile(const char* label, const char* filename, Soundfile** sf_zone) = 0;

        // -- metadata declarations

        virtual void declare(FAUSTFLOAT*, const char*, const char*) {}
};

#endif
/************************************************************************
 FAUST Architecture File
 Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
 ---------------------------------------------------------------------
 This Architecture section is free software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 3 of
 the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; If not, see <http://www.gnu.org/licenses/>.
 
 EXCEPTION : As a special exception, you may create a larger work
 that contains this FAUST architecture section and distribute
 that work under terms of your choice, so long as this FAUST
 architecture section is not modified.
 ************************************************************************/

#ifndef FAUST_PATHBUILDER_H
#define FAUST_PATHBUILDER_H

#include <vector>
#include <string>
#include <algorithm>

/*******************************************************************************
 * PathBuilder : Faust User Interface
 * Helper class to build complete hierarchical path for UI items.
 ******************************************************************************/

class PathBuilder
{

    protected:
    
        std::vector<std::string> fControlsLevel;
       
    public:
    
        PathBuilder() {}
        virtual ~PathBuilder() {}
    
        std::string buildPath(const std::string& label) 
        {
            std::string res = "/";
            for (size_t i = 0; i < fControlsLevel.size(); i++) {
                res += fControlsLevel[i];
                res += "/";
            }
            res += label;
            std::replace(res.begin(), res.end(), ' ', '_');
            return res;
        }
    
        void pushLabel(const std::string& label) { fControlsLevel.push_back(label); }
        void popLabel() { fControlsLevel.pop_back(); }
    
};

#endif  // FAUST_PATHBUILDER_H

/*******************************************************************************
 * MapUI : Faust User Interface
 * This class creates a map of complete hierarchical path and zones for each UI items.
 ******************************************************************************/

class MapUI : public UI, public PathBuilder
{
    
    protected:
    
        // Complete path map
        std::map<std::string, FAUSTFLOAT*> fPathZoneMap;
    
        // Label zone map
        std::map<std::string, FAUSTFLOAT*> fLabelZoneMap;
    
    public:
        
        MapUI() {};
        virtual ~MapUI() {};
        
        // -- widget's layouts
        void openTabBox(const char* label)
        {
            fControlsLevel.push_back(label);
        }
        void openHorizontalBox(const char* label)
        {
            fControlsLevel.push_back(label);
        }
        void openVerticalBox(const char* label)
        {
            fControlsLevel.push_back(label);
        }
        void closeBox()
        {
            fControlsLevel.pop_back();
        }
        
        // -- active widgets
        void addButton(const char* label, FAUSTFLOAT* zone)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        void addCheckButton(const char* label, FAUSTFLOAT* zone)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        
        // -- passive widgets
        void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT fmin, FAUSTFLOAT fmax)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
        void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT fmin, FAUSTFLOAT fmax)
        {
            fPathZoneMap[buildPath(label)] = zone;
            fLabelZoneMap[label] = zone;
        }
    
        // -- soundfiles
        virtual void addSoundfile(const char* label, const char* filename, Soundfile** sf_zone) {}
        
        // -- metadata declarations
        void declare(FAUSTFLOAT* zone, const char* key, const char* val)
        {}
        
        // set/get
        void setParamValue(const std::string& path, FAUSTFLOAT value)
        {
            if (fPathZoneMap.find(path) != fPathZoneMap.end()) {
                *fPathZoneMap[path] = value;
            } else if (fLabelZoneMap.find(path) != fLabelZoneMap.end()) {
                *fLabelZoneMap[path] = value;
            }
        }
        
        FAUSTFLOAT getParamValue(const std::string& path)
        {
            if (fPathZoneMap.find(path) != fPathZoneMap.end()) {
                return *fPathZoneMap[path];
            } else if (fLabelZoneMap.find(path) != fLabelZoneMap.end()) {
                return *fLabelZoneMap[path];
            } else {
                return FAUSTFLOAT(0);
            }
        }
    
        // map access 
        std::map<std::string, FAUSTFLOAT*>& getMap() { return fPathZoneMap; }
        
        int getParamsCount() { return int(fPathZoneMap.size()); }
        
        std::string getParamAddress(int index)
        { 
            std::map<std::string, FAUSTFLOAT*>::iterator it = fPathZoneMap.begin();
            while (index-- > 0 && it++ != fPathZoneMap.end()) {}
            return (*it).first;
        }
    
        std::string getParamAddress(FAUSTFLOAT* zone)
        {
            std::map<std::string, FAUSTFLOAT*>::iterator it = fPathZoneMap.begin();
            do {
                if ((*it).second == zone) return (*it).first;
            }
            while (it++ != fPathZoneMap.end());
            return "";
        }
    
        static bool endsWith(std::string const& str, std::string const& end)
        {
            size_t l1 = str.length();
            size_t l2 = end.length();
            return (l1 >= l2) && (0 == str.compare(l1 - l2, l2, end));
        }
};


#endif // FAUST_MAPUI_H
/************************************************************************
 FAUST Architecture File
 Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
 ---------------------------------------------------------------------
 This Architecture section is free software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 3 of
 the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; If not, see <http://www.gnu.org/licenses/>.
 
 EXCEPTION : As a special exception, you may create a larger work
 that contains this FAUST architecture section and distribute
 that work under terms of your choice, so long as this FAUST
 architecture section is not modified.
 ************************************************************************/

#ifndef __meta__
#define __meta__

struct Meta
{
    virtual void declare(const char* key, const char* value) = 0;
    virtual ~Meta() {};
};

#endif
/************************************************************************
 FAUST Architecture File
 Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
 ---------------------------------------------------------------------
 This Architecture section is free software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 3 of
 the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; If not, see <http://www.gnu.org/licenses/>.
 
 EXCEPTION : As a special exception, you may create a larger work
 that contains this FAUST architecture section and distribute
 that work under terms of your choice, so long as this FAUST
 architecture section is not modified.
 ************************************************************************/

#ifndef __dsp__
#define __dsp__

#include <string>
#include <vector>

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

class UI;
struct Meta;

/**
 * DSP memory manager.
 */

struct dsp_memory_manager {
    
    virtual ~dsp_memory_manager() {}
    
    virtual void* allocate(size_t size) = 0;
    virtual void destroy(void* ptr) = 0;
    
};

/**
* Signal processor definition.
*/

class dsp {

    public:

        dsp() {}
        virtual ~dsp() {}

        /* Return instance number of audio inputs */
        virtual int getNumInputs() = 0;
    
        /* Return instance number of audio outputs */
        virtual int getNumOutputs() = 0;
    
        /**
         * Trigger the ui_interface parameter with instance specific calls
         * to 'addBtton', 'addVerticalSlider'... in order to build the UI.
         *
         * @param ui_interface - the user interface builder
         */
        virtual void buildUserInterface(UI* ui_interface) = 0;
    
        /* Returns the sample rate currently used by the instance */
        virtual int getSampleRate() = 0;
    
        /**
         * Global init, calls the following methods:
         * - static class 'classInit': static tables initialization
         * - 'instanceInit': constants and instance state initialization
         *
         * @param samplingRate - the sampling rate in Hertz
         */
        virtual void init(int samplingRate) = 0;

        /**
         * Init instance state
         *
         * @param samplingRate - the sampling rate in Hertz
         */
        virtual void instanceInit(int samplingRate) = 0;

        /**
         * Init instance constant state
         *
         * @param samplingRate - the sampling rate in Hertz
         */
        virtual void instanceConstants(int samplingRate) = 0;
    
        /* Init default control parameters values */
        virtual void instanceResetUserInterface() = 0;
    
        /* Init instance state (delay lines...) */
        virtual void instanceClear() = 0;
 
        /**
         * Return a clone of the instance.
         *
         * @return a copy of the instance on success, otherwise a null pointer.
         */
        virtual dsp* clone() = 0;
    
        /**
         * Trigger the Meta* parameter with instance specific calls to 'declare' (key, value) metadata.
         *
         * @param m - the Meta* meta user
         */
        virtual void metadata(Meta* m) = 0;
    
        /**
         * DSP instance computation, to be called with successive in/out audio buffers.
         *
         * @param count - the number of frames to compute
         * @param inputs - the input audio buffers as an array of non-interleaved FAUSTFLOAT samples (eiher float, double or quad)
         * @param outputs - the output audio buffers as an array of non-interleaved FAUSTFLOAT samples (eiher float, double or quad)
         *
         */
        virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) = 0;
    
        /**
         * DSP instance computation: alternative method to be used by subclasses.
         *
         * @param date_usec - the timestamp in microsec given by audio driver.
         * @param count - the number of frames to compute
         * @param inputs - the input audio buffers as an array of non-interleaved FAUSTFLOAT samples (eiher float, double or quad)
         * @param outputs - the output audio buffers as an array of non-interleaved FAUSTFLOAT samples (eiher float, double or quad)
         *
         */
        virtual void compute(double /*date_usec*/, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) { compute(count, inputs, outputs); }
       
};

/**
 * Generic DSP decorator.
 */

class decorator_dsp : public dsp {

    protected:

        dsp* fDSP;

    public:

        decorator_dsp(dsp* dsp = 0):fDSP(dsp) {}
        virtual ~decorator_dsp() { delete fDSP; }

        virtual int getNumInputs() { return fDSP->getNumInputs(); }
        virtual int getNumOutputs() { return fDSP->getNumOutputs(); }
        virtual void buildUserInterface(UI* ui_interface) { fDSP->buildUserInterface(ui_interface); }
        virtual int getSampleRate() { return fDSP->getSampleRate(); }
        virtual void init(int samplingRate) { fDSP->init(samplingRate); }
        virtual void instanceInit(int samplingRate) { fDSP->instanceInit(samplingRate); }
        virtual void instanceConstants(int samplingRate) { fDSP->instanceConstants(samplingRate); }
        virtual void instanceResetUserInterface() { fDSP->instanceResetUserInterface(); }
        virtual void instanceClear() { fDSP->instanceClear(); }
        virtual decorator_dsp* clone() { return new decorator_dsp(fDSP->clone()); }
        virtual void metadata(Meta* m) { fDSP->metadata(m); }
        // Beware: subclasses usually have to overload the two 'compute' methods
        virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) { fDSP->compute(count, inputs, outputs); }
        virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) { fDSP->compute(date_usec, count, inputs, outputs); }
    
};

/**
 * DSP factory class.
 */

class dsp_factory {
    
    protected:
    
        // So that to force sub-classes to use deleteDSPFactory(dsp_factory* factory);
        virtual ~dsp_factory() {}
    
    public:
    
        virtual std::string getName() = 0;
        virtual std::string getSHAKey() = 0;
        virtual std::string getDSPCode() = 0;
        virtual std::string getCompileOptions() = 0;
        virtual std::vector<std::string> getLibraryList() = 0;
        virtual std::vector<std::string> getIncludePathnames() = 0;
    
        virtual dsp* createDSPInstance() = 0;
    
        virtual void setMemoryManager(dsp_memory_manager* manager) = 0;
        virtual dsp_memory_manager* getMemoryManager() = 0;
    
};

/**
 * On Intel set FZ (Flush to Zero) and DAZ (Denormals Are Zero)
 * flags to avoid costly denormals.
 */

#ifdef __SSE__
    #include <xmmintrin.h>
    #ifdef __SSE2__
        #define AVOIDDENORMALS _mm_setcsr(_mm_getcsr() | 0x8040)
    #else
        #define AVOIDDENORMALS _mm_setcsr(_mm_getcsr() | 0x8000)
    #endif
#else
    #define AVOIDDENORMALS
#endif

#endif


#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif 

#include <algorithm>
#include <cmath>
#include <math.h>

static float mydsp_faustpower2_f(float value) {
	return (value * value);
	
}

#ifndef FAUSTCLASS 
#define FAUSTCLASS mydsp
#endif
#ifdef __APPLE__ 
#define exp10f __exp10f
#define exp10 __exp10
#endif

class mydsp : public dsp {
	
 private:
	
	FAUSTFLOAT fVslider0;
	float fRec0[2];
	int iRec7[2];
	float fRec13[2];
	FAUSTFLOAT fHslider0;
	float fRec16[2];
	float fRec14[2];
	int IOTA;
	float fRec15[2048];
	int fSamplingFreq;
	float fConst0;
	float fConst1;
	float fConst2;
	FAUSTFLOAT fHslider1;
	float fRec17[2];
	float fVec0[2];
	float fRec12[2];
	float fRec3[2048];
	float fRec1[2];
	float fRec2[4096];
	FAUSTFLOAT fVslider1;
	float fRec18[2];
	float fConst3;
	float fConst4;
	float fConst5;
	float fConst6;
	float fConst7;
	float fConst8;
	float fConst9;
	float fConst10;
	float fConst11;
	float fConst12;
	float fConst13;
	float fConst14;
	float fConst15;
	float fConst16;
	float fConst17;
	float fConst18;
	float fConst19;
	float fConst20;
	float fConst21;
	float fRec32[2];
	float fRec31[2];
	float fVec1[2048];
	float fConst22;
	int iConst23;
	int iConst24;
	float fVec2[2048];
	int iConst25;
	float fRec29[2];
	float fConst26;
	float fConst27;
	float fConst28;
	float fConst29;
	float fConst30;
	float fConst31;
	float fConst32;
	float fConst33;
	float fConst34;
	float fConst35;
	float fConst36;
	float fRec36[2];
	float fRec35[2];
	float fVec3[2048];
	float fConst37;
	int iConst38;
	float fVec4[4096];
	int iConst39;
	float fRec33[2];
	float fConst40;
	float fConst41;
	float fConst42;
	float fConst43;
	float fConst44;
	float fConst45;
	float fConst46;
	float fConst47;
	float fConst48;
	float fConst49;
	float fConst50;
	float fRec40[2];
	float fRec39[2];
	float fVec5[2048];
	float fConst51;
	int iConst52;
	float fVec6[4096];
	int iConst53;
	float fRec37[2];
	float fConst54;
	float fConst55;
	float fConst56;
	float fConst57;
	float fConst58;
	float fConst59;
	float fConst60;
	float fConst61;
	float fConst62;
	float fConst63;
	float fConst64;
	float fRec44[2];
	float fRec43[2];
	float fVec7[2048];
	float fConst65;
	int iConst66;
	float fVec8[4096];
	int iConst67;
	float fRec41[2];
	float fConst68;
	float fConst69;
	float fConst70;
	float fConst71;
	float fConst72;
	float fConst73;
	float fConst74;
	float fConst75;
	float fConst76;
	float fConst77;
	float fConst78;
	float fRec48[2];
	float fRec47[2];
	float fVec9[2048];
	float fConst79;
	int iConst80;
	float fVec10[2048];
	int iConst81;
	float fRec45[2];
	float fConst82;
	float fConst83;
	float fConst84;
	float fConst85;
	float fConst86;
	float fConst87;
	float fConst88;
	float fConst89;
	float fConst90;
	float fConst91;
	float fConst92;
	float fRec52[2];
	float fRec51[2];
	float fVec11[2048];
	float fConst93;
	int iConst94;
	float fVec12[4096];
	int iConst95;
	float fRec49[2];
	float fConst96;
	float fConst97;
	float fConst98;
	float fConst99;
	float fConst100;
	float fConst101;
	float fConst102;
	float fConst103;
	float fConst104;
	float fConst105;
	float fConst106;
	float fRec56[2];
	float fRec55[2];
	float fVec13[2048];
	float fConst107;
	int iConst108;
	float fVec14[4096];
	int iConst109;
	float fRec53[2];
	float fConst110;
	float fConst111;
	float fConst112;
	float fConst113;
	float fConst114;
	float fConst115;
	float fConst116;
	float fConst117;
	float fConst118;
	float fConst119;
	float fConst120;
	float fRec60[2];
	float fRec59[2];
	float fVec15[2048];
	float fConst121;
	int iConst122;
	float fVec16[2048];
	int iConst123;
	float fRec57[2];
	float fRec21[3];
	float fRec22[3];
	float fRec23[3];
	float fRec24[3];
	float fRec25[3];
	float fRec26[3];
	float fRec27[3];
	float fRec28[3];
	float fConst124;
	float fRec20[3];
	float fConst125;
	float fRec19[3];
	float fRec62[3];
	float fRec61[3];
	
 public:
	
	void metadata(Meta* m) { 
		m->declare("basics.lib/name", "Faust Basic Element Library");
		m->declare("basics.lib/version", "0.0");
		m->declare("delays.lib/name", "Faust Delay Library");
		m->declare("delays.lib/version", "0.1");
		m->declare("filename", "FaustClarinet");
		m->declare("filters.lib/name", "Faust Filters Library");
		m->declare("filters.lib/version", "0.0");
		m->declare("maths.lib/author", "GRAME");
		m->declare("maths.lib/copyright", "GRAME");
		m->declare("maths.lib/license", "LGPL with exception");
		m->declare("maths.lib/name", "Faust Math Library");
		m->declare("maths.lib/version", "2.1");
		m->declare("name", "FaustClarinet");
		m->declare("routes.lib/name", "Faust Signal Routing Library");
		m->declare("routes.lib/version", "0.0");
		m->declare("signals.lib/name", "Faust Signal Routing Library");
		m->declare("signals.lib/version", "0.0");
	}

	virtual int getNumInputs() {
		return 0;
		
	}
	virtual int getNumOutputs() {
		return 2;
		
	}
	virtual int getInputRate(int channel) {
		int rate;
		switch (channel) {
			default: {
				rate = -1;
				break;
			}
			
		}
		return rate;
		
	}
	virtual int getOutputRate(int channel) {
		int rate;
		switch (channel) {
			case 0: {
				rate = 1;
				break;
			}
			case 1: {
				rate = 1;
				break;
			}
			default: {
				rate = -1;
				break;
			}
			
		}
		return rate;
		
	}
	
	static void classInit(int samplingFreq) {
		
	}
	
	virtual void instanceConstants(int samplingFreq) {
		fSamplingFreq = samplingFreq;
		fConst0 = std::min<float>(192000.0f, std::max<float>(1.0f, float(fSamplingFreq)));
		fConst1 = (0.00882352982f * fConst0);
		fConst2 = (0.00147058826f * fConst0);
		fConst3 = (9424.77832f / fConst0);
		fConst4 = ((1.0f - fConst3) / (fConst3 + 1.0f));
		fConst5 = (1979.20337f / fConst0);
		fConst6 = ((1.0f - fConst5) / (fConst5 + 1.0f));
		fConst7 = std::cos((37699.1133f / fConst0));
		fConst8 = std::floor(((0.219990999f * fConst0) + 0.5f));
		fConst9 = ((0.0f - (6.90775537f * fConst8)) / fConst0);
		fConst10 = std::exp((0.5f * fConst9));
		fConst11 = mydsp_faustpower2_f(fConst10);
		fConst12 = (1.0f - (fConst7 * fConst11));
		fConst13 = (1.0f - fConst11);
		fConst14 = (fConst12 / fConst13);
		fConst15 = std::sqrt(std::max<float>(0.0f, ((mydsp_faustpower2_f(fConst12) / mydsp_faustpower2_f(fConst13)) + -1.0f)));
		fConst16 = (fConst14 - fConst15);
		fConst17 = ((fConst15 + (1.0f - fConst14)) * fConst10);
		fConst18 = ((std::exp((0.333333343f * fConst9)) / fConst10) + -1.0f);
		fConst19 = (1.0f / std::tan((628.318542f / fConst0)));
		fConst20 = (1.0f / (fConst19 + 1.0f));
		fConst21 = (1.0f - fConst19);
		fConst22 = std::floor(((0.0191229992f * fConst0) + 0.5f));
		iConst23 = int(std::min<float>(1024.0f, std::max<float>(0.0f, (fConst8 - fConst22))));
		iConst24 = int(std::min<float>(2700.0f, std::max<float>(0.0f, (0.0599999987f * fConst0))));
		iConst25 = int(std::min<float>(1024.0f, std::max<float>(0.0f, (fConst22 + -1.0f))));
		fConst26 = std::floor(((0.256891012f * fConst0) + 0.5f));
		fConst27 = ((0.0f - (6.90775537f * fConst26)) / fConst0);
		fConst28 = std::exp((0.5f * fConst27));
		fConst29 = mydsp_faustpower2_f(fConst28);
		fConst30 = (1.0f - (fConst7 * fConst29));
		fConst31 = (1.0f - fConst29);
		fConst32 = (fConst30 / fConst31);
		fConst33 = std::sqrt(std::max<float>(0.0f, ((mydsp_faustpower2_f(fConst30) / mydsp_faustpower2_f(fConst31)) + -1.0f)));
		fConst34 = (fConst32 - fConst33);
		fConst35 = ((fConst33 + (1.0f - fConst32)) * fConst28);
		fConst36 = ((std::exp((0.333333343f * fConst27)) / fConst28) + -1.0f);
		fConst37 = std::floor(((0.0273330007f * fConst0) + 0.5f));
		iConst38 = int(std::min<float>(1024.0f, std::max<float>(0.0f, (fConst26 - fConst37))));
		iConst39 = int(std::min<float>(2048.0f, std::max<float>(0.0f, (fConst37 + -1.0f))));
		fConst40 = std::floor(((0.192303002f * fConst0) + 0.5f));
		fConst41 = ((0.0f - (6.90775537f * fConst40)) / fConst0);
		fConst42 = std::exp((0.5f * fConst41));
		fConst43 = mydsp_faustpower2_f(fConst42);
		fConst44 = (1.0f - (fConst7 * fConst43));
		fConst45 = (1.0f - fConst43);
		fConst46 = (fConst44 / fConst45);
		fConst47 = std::sqrt(std::max<float>(0.0f, ((mydsp_faustpower2_f(fConst44) / mydsp_faustpower2_f(fConst45)) + -1.0f)));
		fConst48 = (fConst46 - fConst47);
		fConst49 = ((fConst47 + (1.0f - fConst46)) * fConst42);
		fConst50 = ((std::exp((0.333333343f * fConst41)) / fConst42) + -1.0f);
		fConst51 = std::floor(((0.0292910002f * fConst0) + 0.5f));
		iConst52 = int(std::min<float>(1024.0f, std::max<float>(0.0f, (fConst40 - fConst51))));
		iConst53 = int(std::min<float>(2048.0f, std::max<float>(0.0f, (fConst51 + -1.0f))));
		fConst54 = std::floor(((0.210389003f * fConst0) + 0.5f));
		fConst55 = ((0.0f - (6.90775537f * fConst54)) / fConst0);
		fConst56 = std::exp((0.5f * fConst55));
		fConst57 = mydsp_faustpower2_f(fConst56);
		fConst58 = (1.0f - (fConst7 * fConst57));
		fConst59 = (1.0f - fConst57);
		fConst60 = (fConst58 / fConst59);
		fConst61 = std::sqrt(std::max<float>(0.0f, ((mydsp_faustpower2_f(fConst58) / mydsp_faustpower2_f(fConst59)) + -1.0f)));
		fConst62 = (fConst60 - fConst61);
		fConst63 = ((fConst61 + (1.0f - fConst60)) * fConst56);
		fConst64 = ((std::exp((0.333333343f * fConst55)) / fConst56) + -1.0f);
		fConst65 = std::floor(((0.0244210009f * fConst0) + 0.5f));
		iConst66 = int(std::min<float>(1024.0f, std::max<float>(0.0f, (fConst54 - fConst65))));
		iConst67 = int(std::min<float>(2048.0f, std::max<float>(0.0f, (fConst65 + -1.0f))));
		fConst68 = std::floor(((0.125f * fConst0) + 0.5f));
		fConst69 = ((0.0f - (6.90775537f * fConst68)) / fConst0);
		fConst70 = std::exp((0.5f * fConst69));
		fConst71 = mydsp_faustpower2_f(fConst70);
		fConst72 = (1.0f - (fConst7 * fConst71));
		fConst73 = (1.0f - fConst71);
		fConst74 = (fConst72 / fConst73);
		fConst75 = std::sqrt(std::max<float>(0.0f, ((mydsp_faustpower2_f(fConst72) / mydsp_faustpower2_f(fConst73)) + -1.0f)));
		fConst76 = (fConst74 - fConst75);
		fConst77 = ((fConst75 + (1.0f - fConst74)) * fConst70);
		fConst78 = ((std::exp((0.333333343f * fConst69)) / fConst70) + -1.0f);
		fConst79 = std::floor(((0.0134579996f * fConst0) + 0.5f));
		iConst80 = int(std::min<float>(1024.0f, std::max<float>(0.0f, (fConst68 - fConst79))));
		iConst81 = int(std::min<float>(1024.0f, std::max<float>(0.0f, (fConst79 + -1.0f))));
		fConst82 = std::floor(((0.127837002f * fConst0) + 0.5f));
		fConst83 = ((0.0f - (6.90775537f * fConst82)) / fConst0);
		fConst84 = std::exp((0.5f * fConst83));
		fConst85 = mydsp_faustpower2_f(fConst84);
		fConst86 = (1.0f - (fConst7 * fConst85));
		fConst87 = (1.0f - fConst85);
		fConst88 = (fConst86 / fConst87);
		fConst89 = std::sqrt(std::max<float>(0.0f, ((mydsp_faustpower2_f(fConst86) / mydsp_faustpower2_f(fConst87)) + -1.0f)));
		fConst90 = (fConst88 - fConst89);
		fConst91 = ((fConst89 + (1.0f - fConst88)) * fConst84);
		fConst92 = ((std::exp((0.333333343f * fConst83)) / fConst84) + -1.0f);
		fConst93 = std::floor(((0.0316039994f * fConst0) + 0.5f));
		iConst94 = int(std::min<float>(1024.0f, std::max<float>(0.0f, (fConst82 - fConst93))));
		iConst95 = int(std::min<float>(2048.0f, std::max<float>(0.0f, (fConst93 + -1.0f))));
		fConst96 = std::floor(((0.174713001f * fConst0) + 0.5f));
		fConst97 = ((0.0f - (6.90775537f * fConst96)) / fConst0);
		fConst98 = std::exp((0.5f * fConst97));
		fConst99 = mydsp_faustpower2_f(fConst98);
		fConst100 = (1.0f - (fConst7 * fConst99));
		fConst101 = (1.0f - fConst99);
		fConst102 = (fConst100 / fConst101);
		fConst103 = std::sqrt(std::max<float>(0.0f, ((mydsp_faustpower2_f(fConst100) / mydsp_faustpower2_f(fConst101)) + -1.0f)));
		fConst104 = (fConst102 - fConst103);
		fConst105 = ((fConst103 + (1.0f - fConst102)) * fConst98);
		fConst106 = ((std::exp((0.333333343f * fConst97)) / fConst98) + -1.0f);
		fConst107 = std::floor(((0.0229039993f * fConst0) + 0.5f));
		iConst108 = int(std::min<float>(1024.0f, std::max<float>(0.0f, (fConst96 - fConst107))));
		iConst109 = int(std::min<float>(2048.0f, std::max<float>(0.0f, (fConst107 + -1.0f))));
		fConst110 = std::floor(((0.153128996f * fConst0) + 0.5f));
		fConst111 = ((0.0f - (6.90775537f * fConst110)) / fConst0);
		fConst112 = std::exp((0.5f * fConst111));
		fConst113 = mydsp_faustpower2_f(fConst112);
		fConst114 = (1.0f - (fConst7 * fConst113));
		fConst115 = (1.0f - fConst113);
		fConst116 = (fConst114 / fConst115);
		fConst117 = std::sqrt(std::max<float>(0.0f, ((mydsp_faustpower2_f(fConst114) / mydsp_faustpower2_f(fConst115)) + -1.0f)));
		fConst118 = (fConst116 - fConst117);
		fConst119 = ((fConst117 + (1.0f - fConst116)) * fConst112);
		fConst120 = ((std::exp((0.333333343f * fConst111)) / fConst112) + -1.0f);
		fConst121 = std::floor(((0.0203460008f * fConst0) + 0.5f));
		iConst122 = int(std::min<float>(1024.0f, std::max<float>(0.0f, (fConst110 - fConst121))));
		iConst123 = int(std::min<float>(1024.0f, std::max<float>(0.0f, (fConst121 + -1.0f))));
		fConst124 = (0.0f - ((fConst6 + 1.0f) * std::cos(fConst5)));
		fConst125 = (0.0f - ((fConst4 + 1.0f) * std::cos(fConst3)));
		
	}
	
	virtual void instanceResetUserInterface() {
		fVslider0 = FAUSTFLOAT(-6.0f);
		fHslider0 = FAUSTFLOAT(0.0f);
		fHslider1 = FAUSTFLOAT(1.0f);
		fVslider1 = FAUSTFLOAT(0.0f);
		
	}
	
	virtual void instanceClear() {
		for (int l0 = 0; (l0 < 2); l0 = (l0 + 1)) {
			fRec0[l0] = 0.0f;
			
		}
		for (int l1 = 0; (l1 < 2); l1 = (l1 + 1)) {
			iRec7[l1] = 0;
			
		}
		for (int l2 = 0; (l2 < 2); l2 = (l2 + 1)) {
			fRec13[l2] = 0.0f;
			
		}
		for (int l3 = 0; (l3 < 2); l3 = (l3 + 1)) {
			fRec16[l3] = 0.0f;
			
		}
		for (int l4 = 0; (l4 < 2); l4 = (l4 + 1)) {
			fRec14[l4] = 0.0f;
			
		}
		IOTA = 0;
		for (int l5 = 0; (l5 < 2048); l5 = (l5 + 1)) {
			fRec15[l5] = 0.0f;
			
		}
		for (int l6 = 0; (l6 < 2); l6 = (l6 + 1)) {
			fRec17[l6] = 0.0f;
			
		}
		for (int l7 = 0; (l7 < 2); l7 = (l7 + 1)) {
			fVec0[l7] = 0.0f;
			
		}
		for (int l8 = 0; (l8 < 2); l8 = (l8 + 1)) {
			fRec12[l8] = 0.0f;
			
		}
		for (int l9 = 0; (l9 < 2048); l9 = (l9 + 1)) {
			fRec3[l9] = 0.0f;
			
		}
		for (int l10 = 0; (l10 < 2); l10 = (l10 + 1)) {
			fRec1[l10] = 0.0f;
			
		}
		for (int l11 = 0; (l11 < 4096); l11 = (l11 + 1)) {
			fRec2[l11] = 0.0f;
			
		}
		for (int l12 = 0; (l12 < 2); l12 = (l12 + 1)) {
			fRec18[l12] = 0.0f;
			
		}
		for (int l13 = 0; (l13 < 2); l13 = (l13 + 1)) {
			fRec32[l13] = 0.0f;
			
		}
		for (int l14 = 0; (l14 < 2); l14 = (l14 + 1)) {
			fRec31[l14] = 0.0f;
			
		}
		for (int l15 = 0; (l15 < 2048); l15 = (l15 + 1)) {
			fVec1[l15] = 0.0f;
			
		}
		for (int l16 = 0; (l16 < 2048); l16 = (l16 + 1)) {
			fVec2[l16] = 0.0f;
			
		}
		for (int l17 = 0; (l17 < 2); l17 = (l17 + 1)) {
			fRec29[l17] = 0.0f;
			
		}
		for (int l18 = 0; (l18 < 2); l18 = (l18 + 1)) {
			fRec36[l18] = 0.0f;
			
		}
		for (int l19 = 0; (l19 < 2); l19 = (l19 + 1)) {
			fRec35[l19] = 0.0f;
			
		}
		for (int l20 = 0; (l20 < 2048); l20 = (l20 + 1)) {
			fVec3[l20] = 0.0f;
			
		}
		for (int l21 = 0; (l21 < 4096); l21 = (l21 + 1)) {
			fVec4[l21] = 0.0f;
			
		}
		for (int l22 = 0; (l22 < 2); l22 = (l22 + 1)) {
			fRec33[l22] = 0.0f;
			
		}
		for (int l23 = 0; (l23 < 2); l23 = (l23 + 1)) {
			fRec40[l23] = 0.0f;
			
		}
		for (int l24 = 0; (l24 < 2); l24 = (l24 + 1)) {
			fRec39[l24] = 0.0f;
			
		}
		for (int l25 = 0; (l25 < 2048); l25 = (l25 + 1)) {
			fVec5[l25] = 0.0f;
			
		}
		for (int l26 = 0; (l26 < 4096); l26 = (l26 + 1)) {
			fVec6[l26] = 0.0f;
			
		}
		for (int l27 = 0; (l27 < 2); l27 = (l27 + 1)) {
			fRec37[l27] = 0.0f;
			
		}
		for (int l28 = 0; (l28 < 2); l28 = (l28 + 1)) {
			fRec44[l28] = 0.0f;
			
		}
		for (int l29 = 0; (l29 < 2); l29 = (l29 + 1)) {
			fRec43[l29] = 0.0f;
			
		}
		for (int l30 = 0; (l30 < 2048); l30 = (l30 + 1)) {
			fVec7[l30] = 0.0f;
			
		}
		for (int l31 = 0; (l31 < 4096); l31 = (l31 + 1)) {
			fVec8[l31] = 0.0f;
			
		}
		for (int l32 = 0; (l32 < 2); l32 = (l32 + 1)) {
			fRec41[l32] = 0.0f;
			
		}
		for (int l33 = 0; (l33 < 2); l33 = (l33 + 1)) {
			fRec48[l33] = 0.0f;
			
		}
		for (int l34 = 0; (l34 < 2); l34 = (l34 + 1)) {
			fRec47[l34] = 0.0f;
			
		}
		for (int l35 = 0; (l35 < 2048); l35 = (l35 + 1)) {
			fVec9[l35] = 0.0f;
			
		}
		for (int l36 = 0; (l36 < 2048); l36 = (l36 + 1)) {
			fVec10[l36] = 0.0f;
			
		}
		for (int l37 = 0; (l37 < 2); l37 = (l37 + 1)) {
			fRec45[l37] = 0.0f;
			
		}
		for (int l38 = 0; (l38 < 2); l38 = (l38 + 1)) {
			fRec52[l38] = 0.0f;
			
		}
		for (int l39 = 0; (l39 < 2); l39 = (l39 + 1)) {
			fRec51[l39] = 0.0f;
			
		}
		for (int l40 = 0; (l40 < 2048); l40 = (l40 + 1)) {
			fVec11[l40] = 0.0f;
			
		}
		for (int l41 = 0; (l41 < 4096); l41 = (l41 + 1)) {
			fVec12[l41] = 0.0f;
			
		}
		for (int l42 = 0; (l42 < 2); l42 = (l42 + 1)) {
			fRec49[l42] = 0.0f;
			
		}
		for (int l43 = 0; (l43 < 2); l43 = (l43 + 1)) {
			fRec56[l43] = 0.0f;
			
		}
		for (int l44 = 0; (l44 < 2); l44 = (l44 + 1)) {
			fRec55[l44] = 0.0f;
			
		}
		for (int l45 = 0; (l45 < 2048); l45 = (l45 + 1)) {
			fVec13[l45] = 0.0f;
			
		}
		for (int l46 = 0; (l46 < 4096); l46 = (l46 + 1)) {
			fVec14[l46] = 0.0f;
			
		}
		for (int l47 = 0; (l47 < 2); l47 = (l47 + 1)) {
			fRec53[l47] = 0.0f;
			
		}
		for (int l48 = 0; (l48 < 2); l48 = (l48 + 1)) {
			fRec60[l48] = 0.0f;
			
		}
		for (int l49 = 0; (l49 < 2); l49 = (l49 + 1)) {
			fRec59[l49] = 0.0f;
			
		}
		for (int l50 = 0; (l50 < 2048); l50 = (l50 + 1)) {
			fVec15[l50] = 0.0f;
			
		}
		for (int l51 = 0; (l51 < 2048); l51 = (l51 + 1)) {
			fVec16[l51] = 0.0f;
			
		}
		for (int l52 = 0; (l52 < 2); l52 = (l52 + 1)) {
			fRec57[l52] = 0.0f;
			
		}
		for (int l53 = 0; (l53 < 3); l53 = (l53 + 1)) {
			fRec21[l53] = 0.0f;
			
		}
		for (int l54 = 0; (l54 < 3); l54 = (l54 + 1)) {
			fRec22[l54] = 0.0f;
			
		}
		for (int l55 = 0; (l55 < 3); l55 = (l55 + 1)) {
			fRec23[l55] = 0.0f;
			
		}
		for (int l56 = 0; (l56 < 3); l56 = (l56 + 1)) {
			fRec24[l56] = 0.0f;
			
		}
		for (int l57 = 0; (l57 < 3); l57 = (l57 + 1)) {
			fRec25[l57] = 0.0f;
			
		}
		for (int l58 = 0; (l58 < 3); l58 = (l58 + 1)) {
			fRec26[l58] = 0.0f;
			
		}
		for (int l59 = 0; (l59 < 3); l59 = (l59 + 1)) {
			fRec27[l59] = 0.0f;
			
		}
		for (int l60 = 0; (l60 < 3); l60 = (l60 + 1)) {
			fRec28[l60] = 0.0f;
			
		}
		for (int l61 = 0; (l61 < 3); l61 = (l61 + 1)) {
			fRec20[l61] = 0.0f;
			
		}
		for (int l62 = 0; (l62 < 3); l62 = (l62 + 1)) {
			fRec19[l62] = 0.0f;
			
		}
		for (int l63 = 0; (l63 < 3); l63 = (l63 + 1)) {
			fRec62[l63] = 0.0f;
			
		}
		for (int l64 = 0; (l64 < 3); l64 = (l64 + 1)) {
			fRec61[l64] = 0.0f;
			
		}
		
	}
	
	virtual void init(int samplingFreq) {
		classInit(samplingFreq);
		instanceInit(samplingFreq);
	}
	virtual void instanceInit(int samplingFreq) {
		instanceConstants(samplingFreq);
		instanceResetUserInterface();
		instanceClear();
	}
	
	virtual mydsp* clone() {
		return new mydsp();
	}
	virtual int getSampleRate() {
		return fSamplingFreq;
		
	}
	
	virtual void buildUserInterface(UI* ui_interface) {
		ui_interface->openVerticalBox("FaustClarinet");
		ui_interface->addHorizontalSlider("length", &fHslider1, 1.0f, 0.100000001f, 3.0f, 0.00999999978f);
		ui_interface->addHorizontalSlider("pressure", &fHslider0, 0.0f, 0.0f, 1.0f, 0.00999999978f);
		ui_interface->openHorizontalBox("zita");
		ui_interface->addVerticalSlider("dryWet", &fVslider1, 0.0f, -1.0f, 1.0f, 0.00999999978f);
		ui_interface->addVerticalSlider("level", &fVslider0, -6.0f, -70.0f, 40.0f, 0.100000001f);
		ui_interface->closeBox();
		ui_interface->closeBox();
		
	}
	
	virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {
		FAUSTFLOAT* output0 = outputs[0];
		FAUSTFLOAT* output1 = outputs[1];
		float fSlow0 = (0.00100000005f * std::pow(10.0f, (0.0500000007f * float(fVslider0))));
		float fSlow1 = (0.00999999978f * float(fHslider0));
		float fSlow2 = (0.00999999978f * float(fHslider1));
		float fSlow3 = (0.00100000005f * float(fVslider1));
		for (int i = 0; (i < count); i = (i + 1)) {
			fRec0[0] = (fSlow0 + (0.999000013f * fRec0[1]));
			iRec7[0] = 0;
			fRec13[0] = (0.5f * (fRec13[1] + fRec12[1]));
			float fRec11 = (fRec13[0] + float(iRec7[1]));
			fRec16[0] = (fSlow1 + (0.99000001f * fRec16[1]));
			fRec14[0] = (fRec16[0] + fRec1[1]);
			float fTemp0 = (0.0f - fRec14[1]);
			fRec15[(IOTA & 2047)] = (fRec16[0] + (fTemp0 * std::max<float>(-1.0f, std::min<float>(1.0f, (0.699999988f - (0.310000002f * fTemp0))))));
			fRec17[0] = (fSlow2 + (0.99000001f * fRec17[1]));
			float fTemp1 = (fConst2 * ((0.5f * fRec17[0]) + -0.0500000007f));
			float fTemp2 = (fTemp1 + -1.49999499f);
			int iTemp3 = int(fTemp2);
			int iTemp4 = (int(std::min<float>(fConst1, float(std::max<int>(0, iTemp3)))) + 1);
			float fTemp5 = std::floor(fTemp2);
			float fTemp6 = (fTemp1 + (-1.0f - fTemp5));
			float fTemp7 = (0.0f - fTemp6);
			float fTemp8 = (fTemp1 + (-2.0f - fTemp5));
			float fTemp9 = (0.0f - (0.5f * fTemp8));
			float fTemp10 = (fTemp1 + (-3.0f - fTemp5));
			float fTemp11 = (0.0f - (0.333333343f * fTemp10));
			float fTemp12 = (fTemp1 + (-4.0f - fTemp5));
			float fTemp13 = (0.0f - (0.25f * fTemp12));
			float fTemp14 = (fTemp1 - fTemp5);
			int iTemp15 = (int(std::min<float>(fConst1, float(std::max<int>(0, (iTemp3 + 1))))) + 1);
			float fTemp16 = (0.0f - fTemp8);
			float fTemp17 = (0.0f - (0.5f * fTemp10));
			float fTemp18 = (0.0f - (0.333333343f * fTemp12));
			int iTemp19 = (int(std::min<float>(fConst1, float(std::max<int>(0, (iTemp3 + 2))))) + 1);
			float fTemp20 = (0.0f - fTemp10);
			float fTemp21 = (0.0f - (0.5f * fTemp12));
			float fTemp22 = (fTemp6 * fTemp8);
			int iTemp23 = (int(std::min<float>(fConst1, float(std::max<int>(0, (iTemp3 + 3))))) + 1);
			float fTemp24 = (0.0f - fTemp12);
			float fTemp25 = (fTemp22 * fTemp10);
			int iTemp26 = (int(std::min<float>(fConst1, float(std::max<int>(0, (iTemp3 + 4))))) + 1);
			fVec0[0] = (((((fRec15[((IOTA - iTemp4) & 2047)] * fTemp7) * fTemp9) * fTemp11) * fTemp13) + (fTemp14 * ((((((fRec15[((IOTA - iTemp15) & 2047)] * fTemp16) * fTemp17) * fTemp18) + (0.5f * (((fTemp6 * fRec15[((IOTA - iTemp19) & 2047)]) * fTemp20) * fTemp21))) + (0.166666672f * ((fTemp22 * fRec15[((IOTA - iTemp23) & 2047)]) * fTemp24))) + (0.0416666679f * (fTemp25 * fRec15[((IOTA - iTemp26) & 2047)])))));
			fRec12[0] = fVec0[1];
			float fRec8 = fRec11;
			float fRec9 = fRec12[0];
			float fRec10 = fRec12[0];
			fRec3[(IOTA & 2047)] = fRec8;
			float fRec4 = (((((fTemp7 * fTemp9) * fTemp11) * fTemp13) * fRec3[((IOTA - iTemp4) & 2047)]) + (fTemp14 * ((((((fTemp16 * fTemp17) * fTemp18) * fRec3[((IOTA - iTemp15) & 2047)]) + (0.5f * (((fTemp6 * fTemp20) * fTemp21) * fRec3[((IOTA - iTemp19) & 2047)]))) + (0.166666672f * ((fTemp22 * fTemp24) * fRec3[((IOTA - iTemp23) & 2047)]))) + (0.0416666679f * (fTemp25 * fRec3[((IOTA - iTemp26) & 2047)])))));
			float fRec5 = fRec9;
			float fRec6 = fRec10;
			fRec1[0] = fRec4;
			fRec2[(IOTA & 4095)] = fRec6;
			fRec18[0] = (fSlow3 + (0.999000013f * fRec18[1]));
			float fTemp27 = (fRec18[0] + 1.0f);
			float fTemp28 = (fRec2[((IOTA - 0) & 4095)] * fTemp27);
			float fTemp29 = (1.0f - (0.5f * fTemp27));
			fRec32[0] = (0.0f - (fConst20 * ((fConst21 * fRec32[1]) - (fRec28[1] + fRec28[2]))));
			fRec31[0] = ((fConst16 * fRec31[1]) + (fConst17 * (fRec28[1] + (fConst18 * fRec32[0]))));
			fVec1[(IOTA & 2047)] = ((0.353553385f * fRec31[0]) + 9.99999968e-21f);
			float fTemp30 = (0.300000012f * fRec2[((IOTA - iConst24) & 4095)]);
			float fTemp31 = (((0.600000024f * fRec29[1]) + fVec1[((IOTA - iConst23) & 2047)]) - fTemp30);
			fVec2[(IOTA & 2047)] = fTemp31;
			fRec29[0] = fVec2[((IOTA - iConst25) & 2047)];
			float fRec30 = (0.0f - (0.600000024f * fTemp31));
			fRec36[0] = (0.0f - (fConst20 * ((fConst21 * fRec36[1]) - (fRec24[1] + fRec24[2]))));
			fRec35[0] = ((fConst34 * fRec35[1]) + (fConst35 * (fRec24[1] + (fConst36 * fRec36[0]))));
			fVec3[(IOTA & 2047)] = ((0.353553385f * fRec35[0]) + 9.99999968e-21f);
			float fTemp32 = (((0.600000024f * fRec33[1]) + fVec3[((IOTA - iConst38) & 2047)]) - fTemp30);
			fVec4[(IOTA & 4095)] = fTemp32;
			fRec33[0] = fVec4[((IOTA - iConst39) & 4095)];
			float fRec34 = (0.0f - (0.600000024f * fTemp32));
			fRec40[0] = (0.0f - (fConst20 * ((fConst21 * fRec40[1]) - (fRec26[1] + fRec26[2]))));
			fRec39[0] = ((fConst48 * fRec39[1]) + (fConst49 * (fRec26[1] + (fConst50 * fRec40[0]))));
			fVec5[(IOTA & 2047)] = ((0.353553385f * fRec39[0]) + 9.99999968e-21f);
			float fTemp33 = (fVec5[((IOTA - iConst52) & 2047)] + (fTemp30 + (0.600000024f * fRec37[1])));
			fVec6[(IOTA & 4095)] = fTemp33;
			fRec37[0] = fVec6[((IOTA - iConst53) & 4095)];
			float fRec38 = (0.0f - (0.600000024f * fTemp33));
			fRec44[0] = (0.0f - (fConst20 * ((fConst21 * fRec44[1]) - (fRec22[1] + fRec22[2]))));
			fRec43[0] = ((fConst62 * fRec43[1]) + (fConst63 * (fRec22[1] + (fConst64 * fRec44[0]))));
			fVec7[(IOTA & 2047)] = ((0.353553385f * fRec43[0]) + 9.99999968e-21f);
			float fTemp34 = (fVec7[((IOTA - iConst66) & 2047)] + (fTemp30 + (0.600000024f * fRec41[1])));
			fVec8[(IOTA & 4095)] = fTemp34;
			fRec41[0] = fVec8[((IOTA - iConst67) & 4095)];
			float fRec42 = (0.0f - (0.600000024f * fTemp34));
			fRec48[0] = (0.0f - (fConst20 * ((fConst21 * fRec48[1]) - (fRec27[1] + fRec27[2]))));
			fRec47[0] = ((fConst76 * fRec47[1]) + (fConst77 * (fRec27[1] + (fConst78 * fRec48[0]))));
			fVec9[(IOTA & 2047)] = ((0.353553385f * fRec47[0]) + 9.99999968e-21f);
			float fTemp35 = (fVec9[((IOTA - iConst80) & 2047)] - (fTemp30 + (0.600000024f * fRec45[1])));
			fVec10[(IOTA & 2047)] = fTemp35;
			fRec45[0] = fVec10[((IOTA - iConst81) & 2047)];
			float fRec46 = (0.600000024f * fTemp35);
			fRec52[0] = (0.0f - (fConst20 * ((fConst21 * fRec52[1]) - (fRec23[1] + fRec23[2]))));
			fRec51[0] = ((fConst90 * fRec51[1]) + (fConst91 * (fRec23[1] + (fConst92 * fRec52[0]))));
			fVec11[(IOTA & 2047)] = ((0.353553385f * fRec51[0]) + 9.99999968e-21f);
			float fTemp36 = (fVec11[((IOTA - iConst94) & 2047)] - (fTemp30 + (0.600000024f * fRec49[1])));
			fVec12[(IOTA & 4095)] = fTemp36;
			fRec49[0] = fVec12[((IOTA - iConst95) & 4095)];
			float fRec50 = (0.600000024f * fTemp36);
			fRec56[0] = (0.0f - (fConst20 * ((fConst21 * fRec56[1]) - (fRec25[1] + fRec25[2]))));
			fRec55[0] = ((fConst104 * fRec55[1]) + (fConst105 * (fRec25[1] + (fConst106 * fRec56[0]))));
			fVec13[(IOTA & 2047)] = ((0.353553385f * fRec55[0]) + 9.99999968e-21f);
			float fTemp37 = ((fTemp30 + fVec13[((IOTA - iConst108) & 2047)]) - (0.600000024f * fRec53[1]));
			fVec14[(IOTA & 4095)] = fTemp37;
			fRec53[0] = fVec14[((IOTA - iConst109) & 4095)];
			float fRec54 = (0.600000024f * fTemp37);
			fRec60[0] = (0.0f - (fConst20 * ((fConst21 * fRec60[1]) - (fRec21[1] + fRec21[2]))));
			fRec59[0] = ((fConst118 * fRec59[1]) + (fConst119 * (fRec21[1] + (fConst120 * fRec60[0]))));
			fVec15[(IOTA & 2047)] = ((0.353553385f * fRec59[0]) + 9.99999968e-21f);
			float fTemp38 = ((fVec15[((IOTA - iConst122) & 2047)] + fTemp30) - (0.600000024f * fRec57[1]));
			fVec16[(IOTA & 2047)] = fTemp38;
			fRec57[0] = fVec16[((IOTA - iConst123) & 2047)];
			float fRec58 = (0.600000024f * fTemp38);
			float fTemp39 = (fRec58 + fRec54);
			float fTemp40 = (fRec46 + (fRec50 + fTemp39));
			fRec21[0] = (fRec29[1] + (fRec33[1] + (fRec37[1] + (fRec41[1] + (fRec45[1] + (fRec49[1] + (fRec53[1] + (fRec57[1] + (fRec30 + (fRec34 + (fRec38 + (fRec42 + fTemp40))))))))))));
			fRec22[0] = ((fRec45[1] + (fRec49[1] + (fRec53[1] + (fRec57[1] + fTemp40)))) - (fRec29[1] + (fRec33[1] + (fRec37[1] + (fRec41[1] + (fRec30 + (fRec34 + (fRec42 + fRec38))))))));
			float fTemp41 = (fRec50 + fRec46);
			fRec23[0] = ((fRec37[1] + (fRec41[1] + (fRec53[1] + (fRec57[1] + (fRec38 + (fRec42 + fTemp39)))))) - (fRec29[1] + (fRec33[1] + (fRec45[1] + (fRec49[1] + (fRec30 + (fRec34 + fTemp41)))))));
			fRec24[0] = ((fRec29[1] + (fRec33[1] + (fRec53[1] + (fRec57[1] + (fRec30 + (fRec34 + fTemp39)))))) - (fRec37[1] + (fRec41[1] + (fRec45[1] + (fRec49[1] + (fRec38 + (fRec42 + fTemp41)))))));
			float fTemp42 = (fRec58 + fRec50);
			float fTemp43 = (fRec54 + fRec46);
			fRec25[0] = ((fRec33[1] + (fRec41[1] + (fRec49[1] + (fRec57[1] + (fRec34 + (fRec42 + fTemp42)))))) - (fRec29[1] + (fRec37[1] + (fRec45[1] + (fRec53[1] + (fRec30 + (fRec38 + fTemp43)))))));
			fRec26[0] = ((fRec29[1] + (fRec37[1] + (fRec49[1] + (fRec57[1] + (fRec30 + (fRec38 + fTemp42)))))) - (fRec33[1] + (fRec41[1] + (fRec45[1] + (fRec53[1] + (fRec34 + (fRec42 + fTemp43)))))));
			float fTemp44 = (fRec58 + fRec46);
			float fTemp45 = (fRec54 + fRec50);
			fRec27[0] = ((fRec29[1] + (fRec41[1] + (fRec45[1] + (fRec57[1] + (fRec30 + (fRec42 + fTemp44)))))) - (fRec33[1] + (fRec37[1] + (fRec49[1] + (fRec53[1] + (fRec34 + (fRec38 + fTemp45)))))));
			fRec28[0] = ((fRec33[1] + (fRec37[1] + (fRec45[1] + (fRec57[1] + (fRec34 + (fRec38 + fTemp44)))))) - (fRec29[1] + (fRec41[1] + (fRec49[1] + (fRec53[1] + (fRec30 + (fRec42 + fTemp45)))))));
			float fTemp46 = (0.370000005f * (fRec22[0] + fRec23[0]));
			float fTemp47 = (fConst124 * fRec20[1]);
			fRec20[0] = (fTemp46 - (fTemp47 + (fConst6 * fRec20[2])));
			float fTemp48 = (fConst6 * fRec20[0]);
			float fTemp49 = (0.5f * ((fTemp48 + (fRec20[2] + (fTemp46 + fTemp47))) + ((fTemp48 + (fTemp47 + fRec20[2])) - fTemp46)));
			float fTemp50 = (fConst125 * fRec19[1]);
			fRec19[0] = (fTemp49 - (fTemp50 + (fConst4 * fRec19[2])));
			float fTemp51 = (fConst4 * fRec19[0]);
			output0[i] = FAUSTFLOAT((0.5f * (fRec0[0] * (fTemp28 + (fTemp29 * ((fTemp51 + (fRec19[2] + (fTemp49 + fTemp50))) + ((fTemp51 + (fTemp50 + fRec19[2])) - fTemp49)))))));
			float fTemp52 = (0.370000005f * (fRec22[0] - fRec23[0]));
			float fTemp53 = (fConst124 * fRec62[1]);
			fRec62[0] = (fTemp52 - (fTemp53 + (fConst6 * fRec62[2])));
			float fTemp54 = (fConst6 * fRec62[0]);
			float fTemp55 = (0.5f * ((fTemp54 + (fRec62[2] + (fTemp52 + fTemp53))) + ((fTemp54 + (fTemp53 + fRec62[2])) - fTemp52)));
			float fTemp56 = (fConst125 * fRec61[1]);
			fRec61[0] = (fTemp55 - (fTemp56 + (fConst4 * fRec61[2])));
			float fTemp57 = (fConst4 * fRec61[0]);
			output1[i] = FAUSTFLOAT((0.5f * (fRec0[0] * (fTemp28 + (fTemp29 * ((fTemp57 + (fRec61[2] + (fTemp55 + fTemp56))) + ((fTemp57 + (fTemp56 + fRec61[2])) - fTemp55)))))));
			fRec0[1] = fRec0[0];
			iRec7[1] = iRec7[0];
			fRec13[1] = fRec13[0];
			fRec16[1] = fRec16[0];
			fRec14[1] = fRec14[0];
			IOTA = (IOTA + 1);
			fRec17[1] = fRec17[0];
			fVec0[1] = fVec0[0];
			fRec12[1] = fRec12[0];
			fRec1[1] = fRec1[0];
			fRec18[1] = fRec18[0];
			fRec32[1] = fRec32[0];
			fRec31[1] = fRec31[0];
			fRec29[1] = fRec29[0];
			fRec36[1] = fRec36[0];
			fRec35[1] = fRec35[0];
			fRec33[1] = fRec33[0];
			fRec40[1] = fRec40[0];
			fRec39[1] = fRec39[0];
			fRec37[1] = fRec37[0];
			fRec44[1] = fRec44[0];
			fRec43[1] = fRec43[0];
			fRec41[1] = fRec41[0];
			fRec48[1] = fRec48[0];
			fRec47[1] = fRec47[0];
			fRec45[1] = fRec45[0];
			fRec52[1] = fRec52[0];
			fRec51[1] = fRec51[0];
			fRec49[1] = fRec49[0];
			fRec56[1] = fRec56[0];
			fRec55[1] = fRec55[0];
			fRec53[1] = fRec53[0];
			fRec60[1] = fRec60[0];
			fRec59[1] = fRec59[0];
			fRec57[1] = fRec57[0];
			fRec21[2] = fRec21[1];
			fRec21[1] = fRec21[0];
			fRec22[2] = fRec22[1];
			fRec22[1] = fRec22[0];
			fRec23[2] = fRec23[1];
			fRec23[1] = fRec23[0];
			fRec24[2] = fRec24[1];
			fRec24[1] = fRec24[0];
			fRec25[2] = fRec25[1];
			fRec25[1] = fRec25[0];
			fRec26[2] = fRec26[1];
			fRec26[1] = fRec26[0];
			fRec27[2] = fRec27[1];
			fRec27[1] = fRec27[0];
			fRec28[2] = fRec28[1];
			fRec28[1] = fRec28[0];
			fRec20[2] = fRec20[1];
			fRec20[1] = fRec20[0];
			fRec19[2] = fRec19[1];
			fRec19[1] = fRec19[0];
			fRec62[2] = fRec62[1];
			fRec62[1] = fRec62[0];
			fRec61[2] = fRec61[1];
			fRec61[1] = fRec61[0];
			
		}
		
	}

	
};

#define MULT_16 2147483647
#define DIV_16 4.6566129e-10

FaustClarinet::FaustClarinet() : AudioStream((fDSP = new mydsp())->getNumInputs(), new audio_block_t*[fDSP->getNumInputs()])
{
	UI = new MapUI();
	fDSP->init(AUDIO_SAMPLE_RATE_EXACT);
	fDSP->buildUserInterface(UI);
	// allocating Faust inputs
	if(fDSP->getNumInputs()>0){ 
		fInChannel = new float*[fDSP->getNumInputs()];
		for(int i=0; i<fDSP->getNumInputs(); i++){
			fInChannel[i] = new float[AUDIO_BLOCK_SAMPLES];
		}
	}
	// allocating Faust outputs
	if(fDSP->getNumOutputs()>0){
		fOutChannel = new float*[fDSP->getNumOutputs()];
		for(int i=0; i<fDSP->getNumOutputs(); i++){
			fOutChannel[i] = new float[AUDIO_BLOCK_SAMPLES];
		}
	}
}

void FaustClarinet::update(void)
{
	audio_block_t *inBlock[fDSP->getNumInputs()], *outBlock[fDSP->getNumOutputs()];
  int32_t val;
	
	if(fDSP->getNumInputs()>0){
		for(int channel=0; channel<fDSP->getNumInputs(); channel++){
			inBlock[channel] = receiveReadOnly(channel);
			for(int i=0; i < AUDIO_BLOCK_SAMPLES; i++) {
				val = inBlock[channel]->data[i] << 16;
				fInChannel[channel][i] = val*DIV_16;
			}
			release(inBlock[channel]);
		}
	}
	
	fDSP->compute(AUDIO_BLOCK_SAMPLES,fInChannel,fOutChannel);
	
	for(int channel=0; channel<fDSP->getNumOutputs(); channel++){
		outBlock[channel] = allocate();
		if(outBlock[channel]){
			for(int i=0; i < AUDIO_BLOCK_SAMPLES; i++) {
				val = fOutChannel[channel][i]*MULT_16;
				outBlock[channel]->data[i] = val >> 16;
			}
			transmit(outBlock[channel],channel);
			release(outBlock[channel]);
		}
	}
}

FaustClarinet::~FaustClarinet(){
	delete fDSP;
	delete UI;
	for(int i=0; i<fDSP->getNumInputs(); i++) {
		delete[] fInChannel[i];
  }
  delete [] fInChannel;
	for (int i=0; i < fDSP->getNumOutputs(); i++) {
		delete[] fOutChannel[i];
  }
  delete [] fOutChannel;
}

void FaustClarinet::setParamValue(const std::string& path, float value){
	UI->setParamValue(path,value);
}

#endif
